<?php

	//This function compiles a PHP script to handle the maintenance of alarms (rather than
	//   requiring database fetches when new data comes in, which can be extremely expensive)
	ob_start();
	
	echo '<';
	echo "?php\r\n";
?>
$query = $db->query('SELECT id FROM alerts WHERE state=1');
$active = array();

$active = array();
while($row = $query->fetch(PDO::FETCH_ASSOC))
{
	$active[] = $row['id'];
}
	
$goingactive = array();
$goinginactive = array();
$updates = array();

<?php

	$hookset = $addins->GetHooks('alert_compile_include');
	if ($hookset !== FALSE)
	{
		foreach($hookset as $h)
		{
			//echo '//Running Hook: '.$h.'\r\n\r\n';
			$h();
		}
	}
			
	
?>

foreach($_REQUEST as $k => $v)
{
	$bits = explode(':',$k);
	if (count($bits) > 2)
	{
		$assetid = $bits[0];
		$property = $bits[1];
		$node = $bits[2];
	}
	else
		continue;
	

<?php

	//If we have hooks for alert compiling, we need to run them here...
	$hookset = $addins->GetHooks('alert_compile_asset');
	if ($hookset !== FALSE)
	{
		$query = $db->query("SELECT id FROM assets WHERE type=0");

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			foreach($hookset as $h)
			{
				$h($row['id']);
			}
		}
	}

	$hookset = $addins->GetHooks('alert_compile_comparison');
	
	$query = $db->query("SELECT assetid,id,function FROM alerts");

	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($row['function'] == "")
		{
			$dd = $row['assetid'].'_-'.$row['id'].'_alert';?>
	if (($assetid == <?php echo $row['assetid'];?>) && ($property == 0) && ($node == <?php echo $row['id'];?>)) 
	{
		if ($v == 0) $bin = false; else $bin = true;<?php
		}
		else
		{ 
			$ps = strstr($row['function'],'[');
			$psx = strstr($row['function'],']');
			$vl = substr($row['function'],$ps+1,($psx - $ps)+2);
			
			//Determine the type of property we are using here....
			$type = 'MEASUREMENT';
			$ass = new Asset($row['assetid']);
			$prp = $ass->GetProperties();
			$px = "";
			foreach($prp as $xx)
			{
				if ($xx->id == $vl)
				{
					$type = $xx->type;
					$px = $xx;
					break;
				}
			}
			
			$parts = explode(' ',$row['function']);
			
			if ($parts[1] == "=") $parts[1] = "==";
			
			if ($type == 'MEASUREMENT') { ?>
	if (($assetid == <?php echo $row['assetid'];?>) && ($property == <?php echo $vl; ?>) && ($node == 'measurement')) {
		if ($v <?php echo $parts[1].' '.$parts[2];?>) $bin = true; else $bin = false;<?php
			} 
			if ($type == 'STATUS') { ?>
	if (($assetid == <?php echo $row['assetid'];?>) && ($property == <?php echo $vl; ?>) && ($node == 'state')) {
		if ($v <?php echo $parts[1].' '.$parts[2];?>) $bin = true; else $bin = false;<?php
			
			}
			
			if ($hookset !== FALSE)
			{
				foreach($hookset as $h)
				{
					//echo '//Running Hook: '.$h.'\r\n\r\n';
					$h($row['assetid'],$px,$parts);
				}
			}
		}
			?>
			
		if ($bin === false) {
			if (in_array(<?php echo $row['id']; ?>,$active)) { 
				$goinginactive[] = <?php echo $row['id']; ?>; 
				$updates['a:<?php echo $row['id'];?>'] = 0;
			}
		
		} 
		else {
			if (!in_array(<?php echo $row['id']; ?>,$active)) {
				$goingactive[] = <?php echo $row['id']; ?>; 
				$updates['a:<?php echo $row['id'];?>'] = 1;
			};
		}
	}
<?php

	
}
?>
}

//Set actives to true...
if (count($goingactive) > 0) 
{
	$db->query("UPDATE alerts SET state = 1 WHERE id IN (".implode(',',$goingactive).")");
	//file_put_contents($sitefolder.'/newalerts.txt',"UPDATE alerts SET status = 1 WHERE id IN (".implode(',',$goingactive).")");
}

//Set inactives to false...
if (count($goinginactive) > 0) 
{
	$db->query("UPDATE alerts SET state = 0 WHERE id IN (".implode(',',$goinginactive).")");
}

//Submit updates to consolidator
if (count($updates) > 0)
{
	ob_start();
	//Get consolidator port for actual profile...
	$query = $db->query('SELECT subport FROM profiles WHERE id=1');

	$submission = 0;
	while($row = $query->fetch(PDO::FETCH_ASSOC))
	{
		$submission = $row['subport'];
	}
	if ($submission != 0)
	{
		ob_start();
		$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
		if ($socket === false) {
			echo "socket_create() failed: reason: " . socket_strerror(socket_last_error()) . "\n";
		}
		
		socket_set_option($socket, SOL_SOCKET, SO_RCVTIMEO, array('sec' => 1, 'usec' => 0));
		socket_set_option($socket, SOL_SOCKET, SO_SNDTIMEO, array('sec' => 1, 'usec' => 0));

		$address = "localhost";
		$service_port = $submission;

		//echo "Attempting to connect to '$address' on port '$service_port'...";
		$result = socket_connect($socket, $address, $service_port);
		if ($result === false) {
			echo "socket_connect() failed.\nReason: ($result) " . socket_strerror(socket_last_error($socket)) . "\n";
		}

		$in = "";
		
		foreach($updates as $k => $v)
		{
			$in .= $k.'='.$v."\r\n";
		}
		
		//echo "Sending Data";
		@socket_write($socket, $in, strlen($in));
		//echo "OK.\n";

		//echo "Closing socket...";
		socket_close($socket);
		//echo "OK.\n\n";
		$content = ob_get_clean();
		if (trim($content) != "")
		{
			file_put_contents($sitefolder.'/submission.txt',$content);
		}
	}
}

<?php
	echo "?";
	echo ">\r\n";
	
	$content = ob_get_clean();
	file_put_contents($sitefolder.'/daq/alerts.php',$content);
	
?>