<?php
/**
 * Provides detail on an existing alert
 *
 * This also scans relationships for possible root causes and offers media
 * files that may be related to the specific issue.
 *
 * @author Steven Harding
 */

	$title = 'Alert List';

	global $installfolder;

	include('include/tmpl.php');
	
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title=Active Alerts');
					ST('ftable');
					
	global $license;
					
	if ($license->violated == true)
	{
		echo '<tr><td><a href="'.$siteroot.'/info/license">ARDI License Error - Too Many Assets For Your Subscription</a></td></tr>';      

	}				

	$query = $db->query('SELECT assets.id,alerts.name as alertname,assetid, assets.name as assetname FROM alerts JOIN assets ON (assets.id = alerts.assetid) WHERE state=1 ORDER BY alerts.name');
	
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{?>
	    <tr><td><a href="<?php echo $siteroot;?>/dashboard/<?php echo $row['assetid'];?>"><?php echo $row['alertname'];?> on <?php echo $row['assetname'];?></a></td></tr>      
<?php
	}?>


    