<?php
	
	if ($editable != true) exit;
	
	include($installfolder.'/model/property.php');
	require_once($installfolder.'/model/asset.php');
	
	$parent = 0;
	
	if (!isset($_REQUEST['asset']))
	{
		exit;
	}
	
	if (isset($_REQUEST['property']))
	{
		$propid = $_REQUEST['property'];
	}
	
	$parent = filter_var($_REQUEST['asset'],FILTER_VALIDATE_INT);
	if ($parent === FALSE) exit;
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM alerts WHERE id='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}
		
		$parent = $propinfo['assetid'];

		$modename = "Update Alert";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Alert";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM alerts WHERE id=".$id);
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
		}
		
		//echo 'Posting?';
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			$errormsg = "";
		
			//print_r($_REQUEST);
		
			if (!isset($_REQUEST['name'])) exit;
			if (!isset($_REQUEST['desc'])) exit;
			
			if (!isset($_REQUEST['rel'])) exit;
			if (!isset($_REQUEST['media'])) exit;
			if (!isset($_REQUEST['typ'])) exit;
			
			
			$name = $_REQUEST['name'];
			$desc = $_REQUEST['desc'];			
			$rel = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
			$media = filter_var($_REQUEST['media'],FILTER_VALIDATE_INT);
			$type = $_REQUEST['typ'];
			
			//if ($type === FALSE) exit;
			if ($media === FALSE) $media = 0;
			if ($rel === FALSE) $rel = 0;
			$options = "";
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid name for your alert.";
			
			//echo 'Dropping Out: '.$errormsg;
			
			if ($errormsg == "")
			{
				//echo 'Working...';
			
				$function = "";
				if ($type == 'compare')
				{
					$prp = $_REQUEST['prop'];
					$style = "raw";
					$bits = explode(' ',$_REQUEST['prop']);
					if (count($bits) > 1)
					{
						$prp = $bits[0];
					}
					$function = '['.$prp.']';
					$function .= ' '.$_REQUEST['cmp'].' ';
					$v = $_REQUEST['value'];
					if (is_numeric($v))
						$function .= $_REQUEST['value'];
					else
						$function .= "'".$_REQUEST['value']."'";
				}
				
				//echo "UPDATE alerts SET name=".$db->quote($name).",relationship=".$rel.",description=".$db->quote($desc).",media=".$media.",function=".$db->quote($function)." WHERE id=".$id;
				$db->query("UPDATE alerts SET name=".$db->quote($name).",relationship=".$rel.",description=".$db->quote($desc).",media=".$media.",function=".$db->quote($function)." WHERE id=".$id);
				include('compile.php');
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
			
			exit;
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['description'] = '';
		$propinfo['relationship'] = 0;
				
		$modename = "Add Alert";
		
		//echo 'Adding Alert';
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
				
			$name = $_REQUEST['name'];
			$type = $_REQUEST['typ'];
			//if ($type === FALSE) $errmessage = "Invalid Type";
				
			if (trim($name) == "") 
				$errormessage = "You must specify a valid name for your alert.";
			else
			{			
				$query = $db->query('SELECT * FROM alerts WHERE assetid='.$parent.' AND name='.$db->quote($name));
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormessage = "Your alert name is not unique to this asset. Please select another name.";
				}
			}
			
			//echo 'Saving...';
			if ($errormessage == "")
			{
			
				//$type = filter_var($_REQUEST['type'],FILTER_VALIDATE_INT);
				//if ($type === FALSE) exit;
				$options = "";
				$rel = filter_var($_REQUEST['rel'],FILTER_VALIDATE_INT);
				if ($rel === FALSE) $rel = 0;
				
				$function = "";
				if ($type != 'dynamic')
				{
					$prp = $_REQUEST['prop'];
					$style = "raw";
					$bits = explode(' ',$_REQUEST['prop']);
					if (count($bits) > 1)
					{
						$prp = $bits[0];
					}
					$function = '['.$prp.']';
					$function .= ' '.$_REQUEST['cmp'].' ';
					$v = $_REQUEST['value'];
					if (is_numeric($v))
						$function .= $_REQUEST['value'];
					else
						$function .= "'".$_REQUEST['value']."'";
				}
				
				//echo "INSERT INTO alerts (name,assetid,state,function,relationship) VALUES (".$db->quote($name).",".$parent.',0,'.$db->quote($function).','.$rel.')';
					
				$db->query("INSERT INTO alerts (name,assetid,state,function,relationship) VALUES (".$db->quote($name).",".$parent.',0,'.$db->quote($function).','.$rel.')');
				//echo 'Trying to compile...';
				include('compile.php');
				//include ($installfolder.'/include/updaterelcache.php');
				//exit;
				header("Location: ".$siteroot.'/alerts/'.$parent);
				exit;
			}
			else
			{
				echo 'Dropped Out "'.$errormessage.'"';
				exit;
			}
		}
		else
		{
			echo 'No Post?';
		}
	}
	
	//include($installfolder.'/include/tmpl.php');
	$function= "";
	if (isset($propinfo['function']) != "")
	{
		$function = $propinfo['function'];
	}
	
	if ($modename == "Delete Alert")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
	
		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your '<?php echo $propinfo['name']?>' alert?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
		<input type="hidden" name="asset" value="<?php echo $parent;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	if ($propinfo['name'] != "")
		$title = "Edit ".$propinfo['name'];
	else
		$title = "Add Alert";
	
	include($installfolder.'/include/tmpl.php');
	
	$thisasset = new Asset($parent);
	$prop = $thisasset->GetLocalProperties();
	$thisasset->GetValues($prop);
	
	if (isset($propid))
	{
		foreach($prop as $p)
		{
			if ($p->id == $propid)
			{
				$propinfo['name'] = $p->name.' High';
				$value = ($p->value['max'] * 0.9);
			}
		}
		$function = $propid." > ".$value;
	}

	T('header-basic','title='.$title);
	?>
	
	<script>
function ChangeType()
{
	if ($('#typ').val() == "compare")
		$('.comparison').fadeIn(500);
	else
		$('.comparison').fadeOut(500);
}

var lastmode = "default";

function UpdateComparisons()
{
	var vv = $("#prop option:selected").val();
	var bits = vv.split(' ');
	var mode = "default";
	if (bits.length > 1)
	{
		mode = bits[1];
	}
	
	if (mode != lastmode)
	{
	
		if (mode == "default")
		{
			$('#cmp').html('<option value="=">Is Equal To</option> \
			<option value="!=">Is Not Equal To</option> \
			<option value=">">Is Greater Than</option> \
			<option value="<">Is Less Than</option>');
		}
		
		if (mode == "GPS")
		{
			$('#cmp').html('<option value="~<">Is Closer Than</option> \
			<option value="~>">Is Further Than</option>');
		}
		
		$('.mode').hide();
		$('.' + mode).fadeIn(500);
	}
	
	lastmode = mode;
}
	</script>
	
	<?php
	ST('section','class=content');?>
		<form method="POST" action="update"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
				<input type="hidden" name="asset" value="<?php echo $parent;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
					ST('ftable');?>
						
    	<tr><td><label>Name : </label></td><td><input style="width: 100%" type="text" name="name" value="<?php echo $propinfo['name']; ?>"/></td></tr>
		<tr><td><label>Description : </label></td><td><textarea style="width: 100%;" name="desc"><?php echo $propinfo['description']; ?></textarea></td></tr>
		<tr><td><label>Relationship : </label></td><td><select name="rel"><option value="">[ None ]</option>
		<?php
			include($installfolder.'/model/relationship.php');
			$dta = Relationships::GetAllRelationships();
			foreach($dta as $d)
			{
				echo '<option value="'.$d->id.'">'.$d->name.'</option>';
			}
		?></select></td></tr>
		<tr><td><label>Media : </label></td><td><select name="media"><option value="">[ None ]</option>
		<?php
			$thisasset = new Asset($parent);
			$media = $thisasset->GetMedia();
			
			foreach($media as $m)
			{
				echo '<option value="'.$d->id.'">'.$d->name.'</option>';
			}
		?></select></td></tr>
		<tr><td><label>Alert Based On : </label></td><td><select id="typ" name="typ" onchange="ChangeType();">
		<option value="dynamic"<?php if ($function == "") echo ' selected';?>>A Data Source</option>
		<option value="compare"<?php if ($function != "") echo ' selected';?>>A Property Value</option>
		</select></td></tr>
		
		<?php
		
		
		$basedon = 0;
		$value = "";
		$comparison = ">";
		if ($function != "")
		{
			$bits = explode(' ',$function);
			$basedon = substr($bits[0],1,strlen($bits[0])-2);
			$comparison = $bits[1];
			$value = $bits[2];
		}
		
		global $addins;
		$allowed = $addins->GetHookData('alert_allowed_types');
		$allowed[] = 'MEASUREMENT';
		$allowed[] = 'STATUS';
		$allowed[] = 'STATE';
		
		
		//print_r($allowed);
		
		?>
		
		<tr class="comparison" <?php if ($function == "") echo 'style="display: none;"';?>><td><label>Trigger Alert When :</label></td><td>
		<select name="prop" id="prop" onchange="UpdateComparisons();">
<?php
		
		foreach($prop as $p)
		{
			//if (!isset($p->value['_dynamics'])) continue;
			if (!in_array($p->type,$allowed)) continue;
			
			echo '<option value="'.$p->id;
			if ($p->type == 'GPS')
			{
				echo ' GPS';
			}
			echo '"';
			if ($p->id == $basedon) echo ' selected';
			echo '>The '.$p->name.'</option>';
		}
?>
		</select><br/><br/>
		<select name="cmp" id="cmp">
		<option value="="<?php if ($comparison == '=') echo ' selected';?>>Is Equal To</option>
		<option value="!="<?php if ($comparison == '!=') echo ' selected';?>>Is Not Equal To</option>
		<option value=">"<?php if ($comparison == '>') echo ' selected';?>>Is Greater Than</option>
		<option value="<"<?php if ($comparison == '<') echo ' selected';?>>Is Less Than</option>
		</select><br/><br/>
		<input type="text" name="value" value="<?php echo $value; ?>"/><span class="mode GPS" style="display: none;"> m </a>
		<span class="mode GPS" style="display: none;">from lat / lon </label>
		<input type="text" name="originlat" value="<?php echo $value; ?>"/>
		<input type="text" name="originlon" value="<?php echo $value; ?>"/></span></td></tr>
		        
        <?php
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>