<?php
/**
 * Provides detail on an existing alert
 *
 * This also scans relationships for possible root causes and offers media
 * files that may be related to the specific issue.
 *
 * @author Steven Harding
 */
	$itemid = filter_var($_REQUEST['assetid'],FILTER_VALIDATE_INT);
	if ($itemid === FALSE) exit;

	if ($itemid != 0)
	{
		$itemdata = array();		
		$query = $db->query('SELECT * FROM alerts WHERE id='.$itemid);

		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$itemdata = $row;
		}	
	}	
	
	
	require_once($installfolder.'/model/asset.php');

	$thisasset = new Asset($itemdata['assetid']);
	$thisasset->Load();

	$title = $thisasset->name.' Alert Detail';

	global $installfolder;

	include('include/tmpl.php');
	
	T('header-basic','title='.$title);

	ST('section','class=content');
		ST('row');
			ST('half');
				ST('box','title='.$thisasset->name.' '.$itemdata['name'].' Alert');?>
				<a href="<?php echo $siteroot; ?>/dashboard/<?php echo $itemdata['assetid'];?>" class="btn btn-default">Asset Dashboard</a>&nbsp;&nbsp;<a href="<?php echo $siteroot; ?>/medialist/<?php echo $itemdata['assetid'];?>" class="btn btn-default">Media and Documentation</a>
<?php
				SS('footer');
?>
	
    This alarm is currently <?php
	if ($itemdata['state'] == 0) 
		echo 'inactive.';
	else
	{
		echo '<strong style="font-weight: bold;">ACTIVE</strong>';
	}
	
	?>  
    </p>
    <p><label><?php echo $itemdata['description'];?></label></p><?php if ($itemdata['media'] != 0) {
		$fldr = $siteroot.'/media/assets/'.$itemid;
    	$query = $db->query('SELECT * FROM mediafiles WHERE mediafiles.id='.$itemdata['media']);
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			echo 'You may find <a href="/media/assets/'.$itemid.'/'.$row['path'].'">'.$row['name'].'</a> useful to diagnose or resolve the fault.';
		}
	};?>
    <?php
    $anypossible = false;
		
	$query = $db->query('SELECT alerts.name,alerts.id, alerts.relationship - '.$itemdata['relationship'].' as reldif,state, assets.name as assetname, assets.id as assetid FROM assetrelclosures JOIN alerts ON (assetrelclosures.parentasset = alerts.assetid) JOIN assets ON (alerts.assetid= assets.id) WHERE assetrelclosures.childasset='.$itemdata['assetid'].' AND alerts.state=1 AND assetrelclosures.relationship <> 3 ORDER BY reldif');
						
	while($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		if ($anypossible == false)
		{
			echo '<p><h4>Possible Contributing Factors</h4>';
			$anypossible = true;
		}
		echo '<a href="'.$siteroot.'/alert/'.$row['id'].'">'.$row['name'].'</a> alert on <a href="'.$siteroot.'/dashboard/'.$row['assetid'].'">'.$row['assetname'].'</a><br/>';
	}
	
	if ($anypossible == true)
	{
		echo '</p>';
	}
	?>
    